您的位置:首页 > 其它

CodeForces 540D Bad Luck Island (概率dp)

2015-11-20 17:43 344 查看
 http://codeforces.com/problemset/problem/540/D

Bad Luck Island

The Bad Luck Island is inhabited by three kinds of species: r rocks, s scissors
and p papers. At some moments of time two random individuals meet (all pairs of individuals can meet equiprobably), and if they belong
to different species, then one individual kills the other one: a rock kills scissors, scissors kill paper, and paper kills a rock. Your task is to determine for each species what is the probability that this species will be the only one to inhabit this island
after a long enough period of time.

Input

The single line contains three integers r, s and p (1 ≤ r, s, p ≤ 100) —
the original number of individuals in the species of rock, scissors and paper, respectively.

Output

Print three space-separated real numbers: the probabilities, at which the rocks, the scissors and the paper will be the only surviving species, respectively. The answer will be considered correct if the relative or absolute error of each number doesn't exceed 10 - 9.

Sample test(s)

input
2 2 2


output
0.333333333333 0.333333333333 0.333333333333


input
2 1 2


output
0.150000000000 0.300000000000 0.550000000000


input
1 1 3


output
0.057142857143 0.657142857143 0.285714285714


题意:

有r个石头,s个剪刀,p个布在一个岛上。问在足够长的时间里,石头,剪刀,布分别存活下来的概率。

思路:

定义dp[i][j][k]:还剩下i个石头,s个剪刀,p个布的概率。

初始dp[r][s][p] = 1;

转移:

总情况数:sum= i*j+j*k+i*k;

则dp[i-1][j][k] = (i*k/sum)*dp[i][j][k];dp[i][j-1][k] = (i*j/sum)*dp[i][j][k];dp[i][j][k-1] = (j*k/sum)*dp[i][j][k];

如果只剩下两种生物在岛上,则可以不用转移了。因为任意两种生物遇到可以肯定谁赢。

因此最后求和(看代码)。

#include <iostream>
#include <cstring>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <limits>
#include <queue>
#include <stack>
#include <vector>
#include <map>

using namespace std;
typedef long long LL;

#define N 110
#define INF 0x3f3f3f3f
#define PI acos (-1.0)
#define EPS 1e-8
#define met(a, b) memset (a, b, sizeof (a))

double dp

;

int main ()
{
int r, s, p;

while (scanf ("%d %d %d", &r, &s, &p) != EOF)
{
met (dp, 0);

dp[r][s][p] = 1.0;

for (int i=r; i>=1; i--)
for (int j=s; j>=1; j--)
for (int k=p; k>=1; k--)
{
double sum = i*j + j*k + i*k;

dp[i-1][j][k] += dp[i][j][k] * i*k*1.0/sum;
dp[i][j-1][k] += dp[i][j][k] * j*i*1.0/sum;
dp[i][j][k-1] += dp[i][j][k] * k*j*1.0/sum;
}

double ans1 = 0, ans2 = 0, ans3 = 0;

for (int i=1; i<=100; i++)
for (int j=0; j<=100; j++)
{
ans1 += dp[i][j][0];
ans2 += dp[0][i][j];
ans3 += dp[j][0][i];
}

printf ("%.10f %.10f %.10f\n", ans1, ans2, ans3);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: